                processor 6502 
                include "vcs.h" 
                include "macro.h" 
                include "jumpmacro.h" 

    SEG.U vars
    ORG $80

customarea1         ds 3
customarea2         ds 3

customarea3         ds 3
customarea4         ds 3
customarea5         ds 3
customarea6         ds 3

customarea9         ds 3
customarea10        ds 3

customarea7         ds 7
customarea8         ds 7


frameCounter        ds 1

    SEG Bank0
    ORG $F000 

Start
    CLEAN_START
    LDA #$A2
    STA COLUPF
    LDA #1
    STA CTRLPF

    JSR BombsInit

Start_Frame 
    VERTICAL_SYNC

; Vertical Blank

    LDX 37
Vertical_Blank  
    STA WSYNC 
    DEX 
    BNE Vertical_Blank 

; Kernel
    STA VBLANK  ; Enable TIA Output

    SYMMETRICALJUMPMANKERNEL JUMP_PF1-DOWN_TOP, DOWN_TOP-JUMP_PF0
    CUSTOMPF1JUMPMANKERNEL DOWN_TOP-DOWN_CUSTOM1, DOWN_CUSTOM1-JUMP_PF0, customarea1, customarea2
    CUSTOMPF0PF1JUMPMANKERNEL DOWN_CUSTOM1-DOWN_CUSTOM2, DOWN_CUSTOM2-JUMP_PF0, customarea3, customarea4, customarea5, customarea6
    SYMMETRICALJUMPMANKERNEL DOWN_CUSTOM2-DOWN_MIDDLE2, DOWN_MIDDLE2-JUMP_PF0
    CUSTOMPF2JUMPMANKERNEL DOWN_MIDDLE2-DOWN_CUSTOM3, DOWN_CUSTOM3-JUMP_PF0, customarea7, customarea8
    SYMMETRICALJUMPMANKERNEL DOWN_CUSTOM3-DOWN_MIDDLE3, DOWN_MIDDLE3-JUMP_PF0
    CUSTOMPF2JUMPMANKERNEL DOWN_MIDDLE3-DOWN_CUSTOM4, DOWN_CUSTOM4-JUMP_PF0, customarea9, customarea10
    SYMMETRICALJUMPMANKERNEL DOWN_CUSTOM4-JUMP_PF0, 0

    STA WSYNC
    LDA #0
    STA PF0
    STA PF1
    STA PF2
    LDA #2      ; Disable TIA Output
    STA VBLANK           

; Overscan
    
    LDX #30 
Overscan        STA WSYNC 
    DEX 
    BNE Overscan 

; Test code for custom zones!
    JSR BombsInit
    INC frameCounter
    LDA frameCounter

    LSR
    BCC FirstZoneFine
    TAY
    LDX 2
Zone1
    LDA customarea1,X
    ORA #%00110000
    STA customarea1,X
    DEX
    BPL Zone1
    TYA
FirstZoneFine

    LSR
    BCC SecondZoneFine
    TAY
    LDX 2
Zone2
    LDA customarea2,X
    ORA #%00110000
    STA customarea2,X
    DEX
    BPL Zone2
    TYA
SecondZoneFine

    LSR
    BCC ThirdZoneFine
    TAY
    LDX 2
Zone3
    LDA customarea3,X
    AND #%01111111
    STA customarea3,X
    LDA customarea5,X
    AND #%00000001
    STA customarea5,X
    DEX
    BPL Zone3
    TYA
ThirdZoneFine

    LSR
    BCC FourthZoneFine
    TAY
    LDX 2
Zone4
    LDA customarea4,X
    AND #%01111111
    STA customarea4,X
    LDA customarea6,X
    AND #%00000001
    STA customarea6,X
    DEX
    BPL Zone4
    TYA
FourthZoneFine

    LSR
    BCC FifthZoneFine
    TAY
    LDX 6
Zone5
    LDA customarea7,X
    AND #%00000000
    STA customarea7,X
    DEX
    BPL Zone5
    TYA
FifthZoneFine

    LSR
    BCC SiththZoneFine
    TAY
    LDX 6
Zone6
    LDA customarea8,X
    AND #%00000000
    STA customarea8,X
    DEX
    BPL Zone6
    TYA
SiththZoneFine

    LSR
    BCC SeventhZoneFine
    TAY
    LDX 2
Zone7
    LDA customarea9,X
    AND #%00000000
    STA customarea9,X
    DEX
    BPL Zone7
    TYA
SeventhZoneFine

    LSR
    BCC Done
    TAY
    LDX 2
Zone8
    LDA customarea10,X
    AND #%00000000
    STA customarea10,X
    DEX
    BPL Zone8
    TYA
Done    

    JMP Start_Frame     ; Build Next Frame

; Initing sub ->DEBUG<-

BombsInit
; Init Custom kernel zones    
    LDX 6
InitCustomZones
    LDA JUMP_PF1+DOWN_CUSTOM1-JUMP_PF0,X
    STA customarea1,X
    STA customarea2,X
    LDA #$FF;JUMP_PF0+DOWN_CUSTOM2-JUMP_PF0,X
    STA customarea3,X
    STA customarea4,X
    LDA JUMP_PF1+DOWN_CUSTOM2-JUMP_PF0,X
    STA customarea5,X
    STA customarea6,X
    LDA JUMP_PF2+DOWN_CUSTOM3-JUMP_PF0,X
    STA customarea7,X
    STA customarea8,X
    LDA JUMP_PF2+DOWN_CUSTOM4-JUMP_PF0,X
    STA customarea9,X
    STA customarea10,X
    DEX
    BPL InitCustomZones
    RTS

; Data

    ORG $F800

JUMP_PF0
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
DOWN_CUSTOM4
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
DOWN_MIDDLE3
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
DOWN_CUSTOM3
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
DOWN_MIDDLE2
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
DOWN_CUSTOM2
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
DOWN_MIDDLE1
DOWN_CUSTOM1
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
DOWN_TOP
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF1
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $F900

JUMP_PF2
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FFFA
    .WORD Start
    .WORD Start
    .WORD Start